#!/usr/bin/perl

# static char sccsid[] = "@(#)33 1.8 src/ll/config_editor/cgi-bin/search_keywords.pl, ll.config, ll_rrur2, rrur21042a 11/6/09 01:30:38\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;

my ($mysql_host, $mysql_user, $mysql_pass, $mysql_db) = get_db_info(0);

my $query = $ENV{QUERY_STRING};
$query =~ s/\s+//g;
$query =~ s/(\+)+//g;

$_ = $query;
if(/search_string=(.+)/)
{
	my $json_str_0 = "Content-type: text/html\n\n";
	my $dbh = DBI->connect("DBI:mysql:database=$mysql_db;host=$mysql_host",$mysql_user,$mysql_pass);
	if(!defined($dbh))
	{
		my $json_str_err = $json_str_0."Error:".DBI->errstr;
		print $json_str_err;
		exit 1;
	}
	
	my $search_string = $1;
	my $wildcard = "%";
	my $sql_str;
	my $sth;

	my $json_str = $json_str_0."{";
	my $isVar = 0;

	# Look for search word in the keywords table
	$sql_str="select keyword,tableName from TLL_CFGKeywords where keyword like \'".$wildcard.$search_string.$wildcard."\'";
	print("Here is the sql_str:".$sql_str);
	debug_log("Here is the sql_str:".$sql_str);
	$sth=$dbh->prepare($sql_str);
	if(!defined($sth->execute()))
	{
		my $json_str_err = $json_str_0."Error:".$dbh->errstr;
		print $json_str_err;
		exit 1;
	}
	# No keyword found, then see if search word is a user-defined or LL variable
	my $rows = $sth->rows();
	if (0==$rows) {
		$isVar = 1;
		$sql_str="select var_name from TLLR_CFGVars where var_name like \'".$wildcard.$search_string.$wildcard."\'";
		print("Here is the new sql_str:".$sql_str);
		debug_log("Here is the new sql_str:".$sql_str);
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			my $json_str_err = $json_str_0."Error:".$dbh->errstr;
			print $json_str_err;
			exit 1;
		}
	}

	$json_str .= "rows:[";
	while(my $ary_ref = $sth->fetchrow_arrayref)
	{
		$json_str .= "{keyword:'".$ary_ref->[0]."',";
		if ($isVar) {
			$json_str .= "tableName:'TLLR_CFGVars'},";
		}
		else {
			$json_str .= "tableName:'".$ary_ref->[1]."'},";
		}
	}
	$json_str =~ s/,$//g;
	$json_str .= "]}";

	debug_log($json_str);
	print $json_str;
	if(defined($sth)) {$sth->finish();}
	$dbh->disconnect();
}
